package event;



import java.util.ArrayList;
import java.util.Random;

import objects.TRNAPropensity;
import environment.Cell;


public abstract class ElongationBindingEventQueue {
	
	
	//abstract methods
	abstract public int size();
	abstract public boolean isEmpty();
	abstract public boolean add(RibosomeEvent newEvent);
	abstract public RibosomeEvent peek();
	abstract public RibosomeEvent poll();
	abstract public RibosomeEvent peek(byte codonID);
	abstract public RibosomeEvent poll(byte codonID);
	abstract public void update(int tRNAID, double cellTime, Cell cp, Random randomGenerator);
	abstract public String toString();
	abstract public String toString(byte codonID);
	
	//event scheduler
	abstract public void scheduleNextElongationBindingEvent(int ribosomeID, double cellTime, int mRNAID, int currentPosition, byte codonID, Random randomGenerator, Cell cp, int numberOfFreeBoundRibosomes, double lastReactionTime);
		
}
