package event;
import java.util.*;
import java.util.HashMap;
import java.util.PriorityQueue;
import java.util.Random;

import objects.FreedAgents;
import objects.StructureCodonTRNA;
import objects.TRNAPropensity;
import environment.Cell;
import agents.TranslationalRNATable;


import utils.Constants;
import utils.Gillespie;
import utils.SequenceUtils;
public class ElongationBindingEventQueueDM {
	private RibosomeEvent elongationBindingEvent;//stores next event
	private ArrayList<ArrayList<Integer>> waitingRibosomesToBindTRNA; // stores the ribsosomes waiting to bing a tRNA
	private int totalWaitingRibosomesToBindTRNA;
	private ArrayList<ArrayList<Integer>> codonsPropensities;
	private ArrayList<ArrayList<Integer>> tRNAsPropensities;
	
	 private HashSet<Integer>[] codontRNAMap;//index is codon; it records the indices of this codon in the codonID array....
	private ArrayList<Double> propensityConstants;
	private double[] propensities;
	private double propensitySum;
	
	private byte[] codonIDs;
	private byte[] tRNAIDs;
	private HashMap<StructureCodonTRNA,Integer> reactions;
	
	private double tRNAbindingRate;
	private boolean nonGognateIntroduceWaitingTime;
	private double  nonGognateWaitingTime;
	private boolean nonCognateChangeBindingRate;
	private double  nonCognateMMConstant;
	public TranslationalRNATable tRNATabe;
	/**
	 * class constructor
	 */
	public ElongationBindingEventQueueDM(double tRNAbindingRate, boolean nonGognateIntroduceWaitingTime, double nonGognateWaitingTime, boolean nonCognateChangeBindingRate, double nonCognateMMConstant, int totalChargedAbundances, Cell Zelle){
		//super();
	         tRNATabe=Zelle.tRNATabe;
		elongationBindingEvent = null;
		waitingRibosomesToBindTRNA = new ArrayList<ArrayList<Integer>>();
		for(int i=0;i<SequenceUtils.codons.codon.length;i++){
			waitingRibosomesToBindTRNA.add(new ArrayList<Integer>());
		}
		totalWaitingRibosomesToBindTRNA = 0;
		
		this.tRNAbindingRate = tRNAbindingRate;
		this.nonGognateIntroduceWaitingTime = nonGognateIntroduceWaitingTime;
		this.nonGognateWaitingTime = nonGognateWaitingTime;
		this.nonCognateChangeBindingRate = nonCognateChangeBindingRate;
		this.nonCognateMMConstant = nonCognateMMConstant;
		
		//SequenceUtils.tRNAtable.getNoOftRNAs()
		double bindingRate=this.tRNAbindingRate;
		propensityConstants = new ArrayList<Double>();
		ArrayList<Double> propensities = new ArrayList<Double>();
		
		waitingRibosomesToBindTRNA = new ArrayList<ArrayList<Integer>>();
		for(int i=0;i<SequenceUtils.codons.codon.length;i++){
			waitingRibosomesToBindTRNA.add(new ArrayList<Integer>());
		}
		
		//array which stores for all codons the affected reactions
		codonsPropensities = new ArrayList<ArrayList<Integer>>();
		for(int i=0;i<SequenceUtils.codons.codon.length;i++){
			codonsPropensities.add(new ArrayList<Integer>());
			
		}
		
		//array which stores for all tRNAs the affected reactions
		tRNAsPropensities = new ArrayList<ArrayList<Integer>>();
		for(int i=0;i<SequenceUtils.tRNAtable.getNoOftRNAs();i++){
			tRNAsPropensities.add(new ArrayList<Integer>());
		}

                
            
                
		 ArrayList<Byte> codonIDs = new ArrayList<Byte>();
		 ArrayList<Byte> tRNAIDs= new ArrayList<Byte>();
		reactions = new HashMap<StructureCodonTRNA,Integer>();
		int index=0;
		propensitySum = 0;
		double buffer;
		ArrayList<Integer> affectedCodons = new ArrayList<Integer>();
		for(byte i=0;i<SequenceUtils.codons.codon.length;i++){
			affectedCodons = SequenceUtils.tRNAtable.getCognates(i);
			for( int j:SequenceUtils.tRNAtable.getNearCognates(i)){
				affectedCodons.add(j);
			}
			if(affectedCodons!=null && !affectedCodons.isEmpty()){
				for( int j:affectedCodons){
					bindingRate = recomputeBindingRate(totalChargedAbundances,totalWaitingRibosomesToBindTRNA);
					propensityConstants.add(this.tRNAbindingRate);
					buffer = bindingRate*waitingRibosomesToBindTRNA.get(i).size()*0;
					propensities.add(buffer);
					propensitySum+=buffer;
					codonsPropensities.get(i).add(index);
					tRNAsPropensities.get(j).add(index);
					codonIDs.add(i);
					tRNAIDs.add((byte)j);
					reactions.put(new StructureCodonTRNA(i,(byte)j), index);
					index++;
				}
			}
		}
		
		this.propensities = new double[propensities.size()];
		this.codonIDs = new byte[codonIDs.size()];
		this.tRNAIDs=new byte[tRNAIDs.size()];
		
                
                //OK what comes here is not used down in the code. 
                //It is the embryonic beginning of an optimisation
                //that I do not have the patience to implement now.
                //the idea is to update only the codons that are affected, instead of 
                //all of them. 
                //I leave this to future releases
//                    HashSet<Integer> tmp = new HashSet();
//                codontRNAMap =  new HashSet [65];
//                int num;
//                for(int i=0;i<65;i++){tmp=new HashSet(); codontRNAMap[i]=tmp;  }
//                
                for(int i=0;i<propensities.size();i++){
			this.propensities[i] = propensities.get(i);
			this.codonIDs[i] =  codonIDs.get(i);
			this.tRNAIDs[i] =  tRNAIDs.get(i);
                       
//                     num =   this.codonIDs[i];
//                        tmp= (HashSet<Integer>)codontRNAMap[2];
//                        
//                        tmp= codontRNAMap[num];
//                                tmp.add(i);
//                       codontRNAMap[num]=tmp;         
		}
//                
                
           /***************** END DEFERRED OPTIMISATION*********/
                
                
	}
	
	/**
	 * recomputes the binding rate
	 * @param totalChargedAbundance
	 * @return
	 */
	private double recomputeBindingRate(double totalChargedAbundance, int totalWaitingRibosomesToBindTRNA){
		double bindingRate=this.tRNAbindingRate;
		if(nonCognateChangeBindingRate){
			bindingRate = (double) bindingRate*(this.nonCognateMMConstant/(totalChargedAbundance/totalWaitingRibosomesToBindTRNA + this.nonCognateMMConstant));
		}
		return bindingRate;
	}
	
        
        
        	/**   THIS IS PART OF THE DEFERRED optimisation SHOULD NOT BE CALLED EVER
	 * recompute all propensities that have changed when codon codeNum changed
	 * @param totalChargedAbundance
	 */
	public void recomputePropensities(Cell cp, int codeNum){
//		
            
            System.out.println("You should not call recomputePropensitie (Cell, int)..exiting");
            System.exit(-1);
           int index;
			double bindingRate=this.tRNAbindingRate;
			this.propensitySum = 0;
			//double totalTRNAChargedAbundance = cp.gettRNATotalChargedAbundances()
                        HashSet<Integer> tmp =codontRNAMap[codeNum];
                        
                        for(Iterator<Integer> i = tmp.iterator();i.hasNext();)
{
                        
    index = i.next();
			this.propensitySum-=propensities[index];
			
                        
                                 
                        double tRNAChargedAbundance;
				tRNAChargedAbundance =   tRNATabe.gettRNAChargeAbundance(tRNAIDs[index]);
				bindingRate =this.tRNAbindingRate; 
				
				propensities[index] = bindingRate*waitingRibosomesToBindTRNA.get(codonIDs[index]).size()*tRNAChargedAbundance;
				
                                
                                this.propensitySum+=propensities[index];
			
}
                                
	}
        
        
        
	/**
	 * recompute all propensities
	 * @param totalChargedAbundance
	 */
	public void recomputePropensities(Cell cp){
//		if(tRNAID==-1){
			double bindingRate=this.tRNAbindingRate;
			this.propensitySum = 0;
			//double totalTRNAChargedAbundance = cp.gettRNATotalChargedAbundances();
			double tRNAChargedAbundance;
for(int i=0;i<propensities.length;i++){
    
    
tRNAChargedAbundance =   tRNATabe.gettRNAChargeAbundance(tRNAIDs[i]);
bindingRate =this.tRNAbindingRate; 
				 
propensities[i] = bindingRate*waitingRibosomesToBindTRNA.get(codonIDs[i]).size()*tRNAChargedAbundance;
				 
this.propensitySum+=propensities[i];
       }
                              
         
	                                            }
	
	/**
	 * returns the number of events in this queue 0 or 1
	 * @return
	 */
	 public int size(){
		 if(elongationBindingEvent == null){
			 return 0;
		 }
		 return 1;
	 }
	
	/**
	 * returns true if the binding event is null
	 * @return
	 */
	public boolean isEmpty(){
		return elongationBindingEvent==null;
	}
		
	/**
	 * replaces the current binding event with a new one
	 * @param re the new event
	 */
	public boolean add(RibosomeEvent re){
		elongationBindingEvent=re;
		return true;
	}
	
	/**
	 * returns the next binding event
	 * @return
	 */
	public RibosomeEvent peek(){
		return elongationBindingEvent;
	}
	
	/**
	 * returns the next binding event and removes it from the list
	 * @return
	 */
	public RibosomeEvent poll(){
		RibosomeEvent re=elongationBindingEvent;
		elongationBindingEvent = null;
		this.totalWaitingRibosomesToBindTRNA--;
		return re;
	}
	
	/**
	 * peeks for a specific codon
	 * @param codonID
	 * @return
	 */
	public RibosomeEvent peek(byte codonID){
		if(elongationBindingEvent.codonID == codonID){
			return elongationBindingEvent;	
		}
		return null;
	}
	
	/**
	 * pops for a specific codon
	 * @param codonID
	 * @return
	 */
	public RibosomeEvent poll(byte codonID){
		RibosomeEvent re = null;
		if(elongationBindingEvent.codonID == codonID){
			re=elongationBindingEvent;
			elongationBindingEvent = null;
		}
		return re;
	}
	
	/**
	 * returns a string with the event
	 */
	public String toString(){
		return elongationBindingEvent+"";
	}
	
	/**
	 * returns a string with the eventList
	 * @param codonID
	 * @return
	 */
	public String toString(byte codonID){
		String result="";
		if(elongationBindingEvent.codonID == codonID){
			result+=elongationBindingEvent;
		}
		return result;
	}
	
        
        
        
        //this schedules a specific  event for a specific ribosome waiting!!!! 
	public void scheduleNextElongationBindingEvent(int ribosomeID, double cellTime, int mRNAID, int currentPosition, byte codonID, Random randomGenerator, Cell cp){
		
            
            
          	this.waitingRibosomesToBindTRNA.get(codonID).add(ribosomeID);
		this.totalWaitingRibosomesToBindTRNA++;
                 
                
		addNexttRNAToRiboBindingEvent(cellTime, randomGenerator, cp);
	}
        
        
         
        
        //This one is used only when we need to reschedule because, f.e. tRNA numbers changed 
        
	public boolean addNexttRNAToRiboBindingEvent(double cellTime, Random randomGenerator, Cell cp){
		//if an event is currently scheduled, remove it
            unScheduleEvent(randomGenerator,  cp);
            
            boolean result=false;
		if(this.elongationBindingEvent==null){
			//if no event then add the ne
			if(this.totalWaitingRibosomesToBindTRNA > 0){
				this.recomputePropensities(cp);
				result = generateNextElongationBindingEvent(cellTime, randomGenerator, cp);
			}
		} 
                
             
                
		return result;
	}	
        
        
        
        
        
        
        
        
        
	/**
	 * generates an event
	 * @param ribosomeID
	 * @param cellTime
	 * @param mRNAID
	 * @param currentPosition
	 * @param codonID
	 * @param randomGenerator
	 * @param totalChargedAbundance
	 * @param tRNApropensity
	 * @param numberOfFreeBoundRibosomes
	 * @param lastReactionTime
	 * @return
	 */
	private boolean generateNextElongationBindingEvent(double cellTime, Random randomGenerator, Cell cp){
		double nextTime=0;
		boolean result = false;
		nextTime+=Gillespie.computeNextReactionTime(propensitySum, randomGenerator);
		//System.out.println(nextTime);
		int reactionID = Gillespie.getNextReaction(propensitySum*randomGenerator.nextDouble(),propensities);
		//int lastRibosome = randomGenerator.nextInt(this.waitingRibosomesToBindTRNA.get(codonIDs[reactionID]).size()-1);
		if(reactionID==-1) 
                    return false; 
		 
                int pick = this.waitingRibosomesToBindTRNA.get(codonIDs[reactionID]).size();
                int lastRibosome = randomGenerator.nextInt(pick);
		if(lastRibosome>=0){
			int ribosomeID=this.waitingRibosomesToBindTRNA.get(codonIDs[reactionID]).get(lastRibosome);	
			//add new event
			add(new RibosomeEvent(cellTime + nextTime,ribosomeID,cp.getRibosomemRNA(ribosomeID), cp.getRibosomePositionOnmRNA(ribosomeID), Constants.RIBOSOME_ELONGATION_STATE_BOUND,tRNAIDs[reactionID], cp.getRibosomeCodon(ribosomeID),cp.getRibosomeLastReactionTime(ribosomeID)));
			//remove the ribosome from the waiting list
			this.waitingRibosomesToBindTRNA.get(codonIDs[reactionID]).remove(lastRibosome);
			result=true;
		}
		
		return result;
	}
	
        
       
        //This method sets the event to zero, but returns the waiting ribo to the list of waitin ribos
        //it needs to be called whenever the ribo number or tRNA number changes
        private boolean unScheduleEvent(Random randomGenerator, Cell cp){
            
            if(elongationBindingEvent==null) return false;
          
          int ribosome = elongationBindingEvent.ribosomeID;  
         // int mRNA=elongationBindingEvent.mRNAID;
          int codon = elongationBindingEvent.codonID;
          //int trna = elongationBindingEvent.tRNAID;
          
          waitingRibosomesToBindTRNA.get(codon).add(ribosome);
            
            
            //now remove the binding event from the Q
            elongationBindingEvent=null;
            
            //and initiate the cycle of recalculating the propensities and scheduling a new even
            //addNexttRNAToRiboBindingEvent(cp.getCellTime(),randomGenerator,cp);
            
            
            return true;
            
        }
        
	
	 
        
        
        
   //unused for the time being     
        private void addBindingEventToQ(int codon, int ribosome){
            
             waitingRibosomesToBindTRNA.get(codon).add(ribosome);
            totalWaitingRibosomesToBindTRNA++; 
            
            
        }

        
        
        
        
        
        
        
        
        
        
        
        
        
           
        ////////////////////////////////////////////////////////////////
        //  %%%%%%%%%%  UNUSED  %%%%%%%%%%%%%%%%%%%%%%%
        //&&&&&&&&  PART OF THE FUTURE OPTIMISATION &&&&&&&&&&&&&&&&&&&&&
       //the next two methods are the same EXCEPT that the first one 
        //cals a faster form of the recompute propensities method
        //that only recomputes the propensities for a particular codon....This is supposed to make things faster.
        public boolean addNexttRNAToRiboBindingEvent(double cellTime, Random randomGenerator, Cell cp, int codeNum){
		//if an event is currently scheduled, remove it
          
  System.out.println("You should not call this method (addNexttRNAToRiboBindingEvent(double cellTime, Random randomGenerator, Cell cp, int codeNum)");
  System.exit(-1);
            
            unScheduleEvent(randomGenerator,  cp);
            
            boolean result=false;
		if(this.elongationBindingEvent==null){
			//if no event then add the ne
			if(this.totalWaitingRibosomesToBindTRNA > 0){
				this.recomputePropensities(cp,codeNum);
				result = generateNextElongationBindingEvent(cellTime, randomGenerator, cp);
			}
		} 
		return result;
	}
        
        
        
        
    
        
        
        
        public int getNumberOfWaitingRibos(){
            
            return totalWaitingRibosomesToBindTRNA;
            
        }
        
        
        
}



