package objects;

/**
 * a structure that holds the ids of the mRNA and ribosome that got or free/occupied 
 * -1 means that no ribosome/mRNA got free/occupied
 * @author nrz2
 *
 */
public class FreedAgents {
	public int mRNA;
	public int ribosome;
	
	
	public FreedAgents(){
		mRNA = -1;
		ribosome = -1;
	}
	public void reset(){
		mRNA=-1;
		ribosome=-1;
	}
	
	public boolean nothingGotFree(){
		return 	mRNA<0 && ribosome<0;
	}
	
	public boolean justRibosomeGotFree(){
		return 	mRNA<0 && ribosome>=0;
	}
	
	public boolean justmRNAGotFree(){
		return 	mRNA>=0 && ribosome<0;
	}
	
	public boolean mRNAorRibosomeGotFree(){
		return mRNA>=0 || ribosome>=0;
	}
}
