package utils;

public class Constants {

	//codons per mRNA
	public static final int NO_OF_CODONS_PER_MRNA_MIN=200;//200
	public static final int NO_OF_CODONS_PER_MRNA_MAX=800;//1400
	
	//mRNA copy number
	public static final int NO_OF_MRNA=3000;//3000
	public static final int NO_OF_COPIES_PER_MRNA_AVG=5;//5
	public static final double RIBOSOME_AFFINITY_AVG=0.8;
	public static final double RIBOSOME_AFFINITY_STD=0.1;
	
	//IBS move rate
	
	public static final double IBS_MOVE_RATE_MIN=(double)1.0/60.0;
	public static final double IBS_MOVE_RATE_MAX=(double)1.0/2.0;
	
	//files
	public static final String FILE_PATH="results/";
	public static final String FILENAME="cell_state";
	
	
	//ribosomes
	public static final int NO_OF_RIBOSOME_SITES_BEFORE=6;
	public static final int NO_OF_RIBOSOME_SITES_AFTER=5;
	public static final int NO_OF_RIBOSOME_SITES_TOTAL=12;
	public static final int NO_OF_RIBOSOMES=200000;//200000
	public static final double RATIO_OF_FREE_RIBOSOMES=0.1;//200000
	public static final int NO_OF_TRANSLATION_PER_RIBOSOME_MRNA_MAX=9;//200000
	public static final int NO_OF_TRANSLATION_PER_RIBOSOME_MRNA_MIN=1;
	
	public static final double EONGATION_RATE_MIN=(double)12.0;
	public static final double EONGATION_RATE_MAX=(double)15.0;
	
	public static final boolean UNBINDS_FROM_IBS_IF_BUSY =false;
	public static final boolean UNBINDS_FROM_TERMINATION_IF_BUSY =false;
	public static final boolean APPROXIMATE_SYSTEM =false;
	public static final boolean STOCHASTIC_MRNA_COPY_NUMBER =false;
	public static final boolean UNBINDS_FROM_CODON_IF_BUSY =false;
	
	
	public static final boolean DEBUG_MODE =false;
	
	public static final int POLYOSOME_SIZE_PRINT_POINTS=100;
	
	public static final int SIMULATION_TIME = 1;
	
	public static final String AMINO_ACIDS_FILENAME="biodata/amino_acid_codes.csv";
	//public static final String TRNA_ABUNDANCE_FILENAME="biodata/yeast_codon_abundance.csv";
	public static final String TRNA_ABUNDANCE_FILENAME="biodata/mickeyMouse.csv";
	
	public static final byte NO_OF_TRNAS = 46;
	
// from fluit 2007 paper	
	public static final double ELONGATION_COGNATE_PROBABILITY = 0.652;///(605.416666667*4.241419702);//
	public static final double ELONGATION_NEARCOGNATE_PROBABILITY = 0.00062;///(605.416666667*4.241419702);//
	public static final double ELONGATION_COGNATE_RATE = 25;
	public static final double ELONGATION_NEARCOGNATE_RATE = 21.73;
	public static final double ELONGATION_TRANSLOCATION_RATE = 58;
	
	
	public static final double ELONGATION_NONCOGNATE_PROBABILITY = 0.0;

	
	
	public static final byte RIBOSOME_EVENT_TYPE_BINDING = 0;
	public static final byte RIBOSOME_EVENT_TYPE_ELONGATION = 1;

	
	public static final byte RIBOSOME_ELONGATION_STATE_EMPTY = 0;
	public static final byte RIBOSOME_ELONGATION_STATE_BOUND = 1;
	public static final byte RIBOSOME_ELONGATION_STATE_TRANSFER = 2;
	public static final byte RIBOSOME_PERFORMING_RANDOM_WALK = 3;
	
	public static final double NON_COGNATE_WAIT_TIME = 0.0005;///0.0005
	public static final double TRNA_BINDING_RATE = 140;
	
	public static final double TRNA_CHARGE_RATE=47;
	
	public static final int NEXT_EVENT_IS_RIBOSOME_NONE=0;
	public static final int NEXT_EVENT_IS_RIBOSOME_BINDING=1;
	public static final int NEXT_EVENT_IS_RIBOSOME_RANDOM_WALK=2;
	public static final int NEXT_EVENT_IS_RIBOSOME_ELONGATION_BINDING=3;
	public static final int NEXT_EVENT_IS_RIBOSOME_ELONGATION_TRANSFER=4;
	public static final int NEXT_EVENT_IS_RIBOSOME_ELONGATION_TRANSLOCATION=5;
	public static final int NEXT_EVENT_IS_TRNA_CHARGING=6;
	
	public static final boolean NON_COGNATE_INTRODUCE_WAITING_TIME =false;
	public static final String DEBUG_OUPUT_FILE = "output_file.txt";//
	public static final String MRNA_FILENAME = "biodata/orf_coding.fasta";
	public static final String MRNA_ABUNDANCE_FILENAME = "biodata/5UTRs_mRNA_levles_and_synth_rates.csv";
	public static final double IBS_LENGTH_AVG = 54;
	public static final double IBS_SCANNING_RATE = 10;
	public static final double NO_OF_COPIES_PER_MRNA_MIN = 1;
	public static final double NO_OF_SYNTHESISED_PROTEINS_PER_MRNA_MIN = 0;
	
	public static final double STOP_TIME = 10;
	
	public static final boolean NON_COGNATE_CHANGE_BINDING_RATE = true;
	
	public static final long RANDOM_MRNA_SEED = 1234567890;
	
	public static final int CODON_LENGTH = 3;
	
	public static final boolean ELONGATION_BINDING_EVENTS_USE_GILESPIE_DIRECT = true;

	public static final int POISSON_MEAN = 20;
	public static final double RECORD_START_TIME = 100;
	
	public static final int NONE = -1;
	public static final int IBS_POSITION = 0;
	
	public static final double ELONGATION_NEARCOGNATE_PROBABILITY_EXIT_RECOGNITION = 0.989;
	public static final double ELONGATION_COGNATE_PROBABILITY_EXIT_RECOGNITION = 0.31;

	
	public static final boolean STALL_EVENTS_WAIT = true;
	public static final int COLLISIONS_BEFORE_UNBINDS=-1;
}
