package utils;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

import objects.MessengerRNAType;

public class FastaFileParser {

	
	public static ArrayList<MessengerRNAType> fileParser(String filename){
		ArrayList<MessengerRNAType> mRNAtypes=new ArrayList<MessengerRNAType>();
		  BufferedReader reader = null;
	        try
	        {
	            reader = new BufferedReader(new FileReader(filename));
	            String text = null;
	            
	            String currentStrand = "", currentName = "", buffer;
	            byte[] sequence;
	            int countStop,countStart;
		    MessengerRNAType mRNA;
	            while ((text = reader.readLine()) != null){
	            	text=text.trim();
	            	if(!text.isEmpty()){
	            		if(text.startsWith(">")){
					mRNA = getMRNAseq(currentName, currentStrand); 
					if(mRNA!=null){
						mRNAtypes.add(mRNA);
					}
	            			buffer = text;
	            			if(text.contains(" ")){
	            				buffer = text.substring(1, text.indexOf(" "));
	            			}
	            			currentName = buffer.replaceAll(">", "").trim().toUpperCase();
	            			if(!currentName.isEmpty()){
	            				currentStrand = "";
	            			}
	            		} else{
	            			currentStrand+=text;
	            		}
	            	}
	            }
		mRNA = getMRNAseq(currentName, currentStrand); 
		if(mRNA!=null){
			mRNAtypes.add(mRNA);
		}

			
	            
	        } catch (Exception e) {
	            e.printStackTrace();
	        } finally {
	            try
	            {
	                if (reader != null){
	                    reader.close();
	                }
	            } catch (IOException e)
	            {
	                e.printStackTrace();
	            }
	        }
	        return mRNAtypes;
	}

	private static MessengerRNAType getMRNAseq(String currentName, String currentStrand){
	            			
		MessengerRNAType result = null;

	        if(!currentName.isEmpty() && !currentStrand.isEmpty()){
			byte[] sequence = SequenceUtils.messengerRNATrand(currentStrand);
			int countStop,countStart;
			//mRNAtypes.add(new MessengerRNAType(currentName,sequence));
			countStop = SequenceUtils.countTerminationSites(sequence);
			//countStart = SequenceUtils.countStartSites(sequence);
			
			if(countStop != 1 || !SequenceUtils.codons.isSartCodon(sequence[1]) || currentName.startsWith("Q")){
				//System.out.println(currentName +", "+ countStop+", "+ SequenceUtils.codons.isSartCodon(sequence[1]));
			} else{
				result = new MessengerRNAType(currentName,sequence);
			}
		}
		return result;
	}

}
