package utils;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Random;

public class Gillespie {

    
    
     
	 
    
    
    
    
    
    
    /**
	 * computes the next reaction time according to Gillespie algorithm
	 * @param propensitySum the sum of all propensities
	 * @param generator  a random number generator
	 * @return the time of the next reaction
	 */
	public static double computeNextReactionTime(double propensitySum, Random generator){
		return (1/propensitySum)*Math.log(1/generator.nextDouble());
	}
	
	/**
	 * generate the next reaction to take place
	 * @param value the propensity sum multiplied by a random number
	 * @return the index of the next mRNA species likely to attract a ribosome
	 */
	public static  int getNextReaction(double value,double[] ribosomeBindingPropensity){
		double sum=0;
		/*String str = "[";
		
		for (double i:ribosomeBindingPropensity){
			str+=i+", ";
		}
		str+="]";
		System.out.println(str);*/
		for(int i=0;i<ribosomeBindingPropensity.length;i++){
			if(ribosomeBindingPropensity[i]>0){
				sum+=ribosomeBindingPropensity[i];
				if(sum>=value){
					return i;
				}
			}
		}
return -1;
//		throw new RuntimeException("Error with computing next reaction sum:"+value+"\nPropensities: ");
	}
	
	
	/**
	 * generate the next reaction to take place
	 * @param value the propensity sum multiplied by a random number
	 * @return the index of the next mRNA species likely to attract a ribosome
	 */
	public static int getNextReaction(double propensitySum,HashMap<Integer,Double> propensity, double reactionRate){
		double sum=0;
		Integer key;
		Iterator<Integer> it = propensity.keySet().iterator();
		/*String str = "[";
		
		for (int i:propensity.keySet()){
			str+=propensity.get(i)+", ";
		}
		str+="]";
		System.out.println(str);*/
	    while (it.hasNext()) {
	    	key =  it.next();
	    	sum+=propensity.get(key);
			if(sum>=propensitySum){
				return key;
			}
	    }

		throw new RuntimeException("Error with computing next reaction:");
	}
	

}
