package utils;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;

import objects.MessengerRNAType;

public class mRNAcsvFile {
	public static ArrayList<MessengerRNAType> fileParser(String filename, double ibsLength, double concentration, double proteinConcentration){
		ArrayList<MessengerRNAType> mRNAtypes=new ArrayList<MessengerRNAType>();
		  BufferedReader reader = null;
	        try
	        {
	            reader = new BufferedReader(new FileReader(filename));
	            String text = null, buffer, name;
	            double IBSlength, abundence, proteinAbundance;
	            StringTokenizer st;
	            int index=0;
	            while ((text = reader.readLine()) != null){
	            	text=text.trim();
	            	if(!text.isEmpty()){
	            		if(!text.startsWith("#")){
	            			st= new StringTokenizer(text,",");
	            			index=0;
	            			IBSlength = ibsLength;
	            			abundence = concentration;
	            			proteinAbundance = proteinConcentration;
	            			name = "";
	            			while(st.hasMoreTokens()){
	            				buffer=st.nextToken().trim();
	            				if(!buffer.isEmpty()){
		            				switch(index){
			            				case 0: name = buffer.toUpperCase();
			            						break;
			            				case 1: IBSlength = Double.parseDouble(buffer);
	            								break;	            				
			            				case 2: abundence = Double.parseDouble(buffer);
	            								break;	            				
			            				case 3: proteinAbundance = Double.parseDouble(buffer);
	            								break;	            				
		            				}
	            				}
	            				index++;
	            			}
	            			if(!name.isEmpty()){
	            				//System.out.println(name);
	            				mRNAtypes.add(new MessengerRNAType(name, IBSlength, abundence,proteinAbundance));
	            			}
	            		}
	            	}
	            }
	            
	        } catch (Exception e) {
	            e.printStackTrace();
	        } finally {
	            try
	            {
	                if (reader != null){
	                    reader.close();
	                }
	            } catch (IOException e)
	            {
	                e.printStackTrace();
	            }
	        }
	        return mRNAtypes;
	}
}
